#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dir.h>
#include  <dos.h>
#include  <conio.h>
#include  <io.h>
#include  <alloc.h>
#include  <time.h>
#include  <ctype.h>
#include  "../stat/pragmas.h"

#define FALSE 0
#define TRUE 1
#define	LABELSIZE	31
							/* these are message attributes. */
#define COMPRESSED 0x08     // Compressed message.
#define MORE 0x40           // message has a second attribute byte.
#define BIGROOM 0x20        // Message uses 16 bits for the room number
#define LOCAL 0x01          // (attr2) message is local-only.
#define CTRL_A 1
#define CTRL_B 2

typedef char label[LABELSIZE];

FILE    *msgdat, *msgout;

char	version[11]		 = "1.2";
char    inputmail[257]   = "msg.69";
char    outputfile[257]  = "message.apl";

label	homeadd = "!skr.olm";
label   fromalias = { 0 };

int expired = 0;
int display = 0;

// Message buffer.
struct {
	label 	soft, 				// Software field
			nodename,           // Nodename
			address,			// Address
			air,				// Region as airport code
			author,             // Author
			roomname,           // Room
			region,             // Region
			state,              // State
			country,            // Country
			phone,              // Phone
			mailto,             // Mail. ('T' field.)
			datestr,            // Date. As ASCII seconds.
			ID,                 // ID number, ASCII string.
			stamp;              // Time stamp, if one exists.
	char    path[513],			// Path
			messagetext[8193],  // Message text.
			sig[81],			// Sig line (BBS Sig)
			comment[257];       // Last comment field, if there is one.
	unsigned char attr, attr2,	// Attribute bytes 1 and 2.
				  room1, room2;	// Room bytes 1 and 2.
	long    lstamp,				// Time Stamp as a long.
			ldate;              // msgbuf.datestr as a long.
} msgbuf;

// These are the total number of structure entries.
int		numlink = 0;	// Total number of link structures.

// Link structure.
typedef struct link {
	label	add1;		// Address 1
	label	add2;		// Address 2
	long	date;		// Date of last activity.
    int     expired;    // set to 1 if the link seems to have gone dead.
	struct link* next;
} link;

link*	firstlink = NULL;
link*	currlink = NULL;

int  	main(int argc);
void 	startup(void);
void	shutdown(void);
int  	readMessage(void);
void	pathstat(void);
void	linkstat(label alias1, label alias2);
void    expire(void);
int  	GetStr(FILE *fil, char *str, int mlen);
int  	LenStr(FILE *fil);
int		isaddress(const char *str);
int		hash(const char* s);

/****************************************************************************/
/* main() -- Look Golden Spud!  it returns an int! :-)                      */
/****************************************************************************/
int main(int argc)
{
int	good = 1;

	printf("\n"
			"Scanner %s (%s %s)\n"
			"\n"
			"By Magrathea @ Skaro, Olympia, (360)491-9605\n"
			"\n" , version, __DATE__, __TIME__);

	if(argc > 1)
		printf("Hmm... You've given me a command line option...I don't understand any"
			   " of those.  So stick your options in the config file instead.\n\n");

	startup();

	// Main loop...
    while((good = readMessage()) != 0) {
        if(good && good != 2)
            pathstat();
    }

    expire();
	shutdown();
	fcloseall();

	if(!expired && !display)	/* no new links?  then don't post a message. */
		unlink("message.apl");

	/* this could be more accurate, but that would require the floating
	   point library... which is way to much bloat for such a small thing. */
	printf("Elapsed time...about %ld seconds.\n", clock()/18);

	return(0);
}

/*
 * Read a message...
 */
int readMessage(void)
{
int	c, c2;
char	commtmp[257];
char    addtemp[513];
label	copy;

	copy[0]					= 0;
	addtemp[0]				= 0;
	commtmp[0]				= 0;
	msgbuf.ID[0]			= 0;
	msgbuf.nodename[0]		= 0;
	msgbuf.sig[0]			= 0;
	msgbuf.path[0]			= 0;
	msgbuf.address[0]		= 0;
	msgbuf.soft[0]			= 0;
	msgbuf.mailto[0]		= 0;
	msgbuf.roomname[0]		= 0;
	msgbuf.author[0]		= 0;
	msgbuf.region[0]		= 0;
	msgbuf.state[0]			= 0;
	msgbuf.phone[0]			= 0;
	msgbuf.country[0]		= 0;
	msgbuf.messagetext[0]	= 0;
    *msgbuf.datestr         = 0;
	msgbuf.attr				= 0;
	msgbuf.attr2			= 0;
	msgbuf.room1			= 0;
	msgbuf.room2			= 0;
	msgbuf.ldate			= 0;
	msgbuf.lstamp			= 0;

	/* find start of message */
	do {
		c = fgetc(msgdat);
	} while (c != 0xFF && c != EOF);

	if (c == EOF)
		return 0;

	msgbuf.attr = fgetc(msgdat);		// Get the first attribute byte.

	if((msgbuf.attr & MORE) != 0)		// Get second attribute byte, if there is one.
		msgbuf.attr2 = fgetc(msgdat);

	if((msgbuf.attr & BIGROOM) != 0)	// room is number 255 or greater, thus there
	{									// is 16 bits of room number.
		msgbuf.room1 = fgetc(msgdat);
		msgbuf.room2 = fgetc(msgdat);
	}
	else								// room is number 254 or less, so theres only
		msgbuf.room1 = fgetc(msgdat);	// 8 bits of room number.

	(void)GetStr(msgdat, msgbuf.ID, 30);  // Get the ID number.

	do {
		c = fgetc(msgdat);

		switch (c)
		{
			case 'A':	(void)GetStr(msgdat, msgbuf.author,   30);	break;
			case 'C':	(void)GetStr(msgdat, copy,			  30);	break;
			case 'D':	(void)GetStr(msgdat, msgbuf.datestr,  30);
						msgbuf.ldate = atol(msgbuf.datestr);		break;
			case 'R':	(void)GetStr(msgdat, msgbuf.roomname, 30);	break;
			case 's':	(void)GetStr(msgdat, msgbuf.soft,     30);	break;
			case 'T':   (void)GetStr(msgdat, msgbuf.mailto,   30);	break;
			case 'P':	(void)GetStr(msgdat, msgbuf.path,    256);	break;
			case 'O':	(void)GetStr(msgdat, msgbuf.nodename, 30);	break;
			case 'o':	(void)GetStr(msgdat, msgbuf.region,   30);	break;
			case 'Q':	(void)GetStr(msgdat, msgbuf.state,    30);	break;
			case 'U':	(void)GetStr(msgdat, msgbuf.country,  30);	break;
			case 'H':	(void)GetStr(msgdat, msgbuf.phone,    30);	break;
			case '.':	(void)GetStr(msgdat, msgbuf.sig,      80);	break;
			case '_':	LenStr(msgdat);								break;
			case 'n':	LenStr(msgdat);								break;
			case 'N':	LenStr(msgdat);								break;
			case '%':	GetStr(msgdat, msgbuf.comment, 256);		break;
			case 'M':												break;
			default:
				do {
					c2 = fgetc(msgdat);
				} while(c2 && c2 !=EOF);
				break;
		}
	} while (c != 'M' && c != EOF);

	if (c == EOF)
		return 0;

	GetStr(msgdat, msgbuf.messagetext, 8192);

	if(copy[0])
		return 2;

	return 1;
}

/***************************************************************************/
/* pathstat() - keeps tabs on network connections...                       */
/* ----------------------------------------------------------------------- */
/* I really don't like this function...  I find it quite ugly...           */
/* I'd be delighted if someone could come up with a nicer one...           */
/* I also think it's going to rival userstat() as the most time-intensive  */
/* part of this program...i'll have to profile it again and find out...    */
/***************************************************************************/
void pathstat(void)
{
char	wpath[513];
char	*ptr;			// pointer to start of current part of path
char	*end;			// pointer to ending bang.
char	*point;         // pointer to period in address.
char    add1[31];       // address 1
char	add2[31];		// address 2
char	air[31];		// current airport code.
char	*good;			// and this is a hack.

	strcpy(wpath, msgbuf.path);
	strcat(wpath, homeadd);

	ptr = wpath;

	if(strchr(ptr, '!'))
		do {
			end = NULL;
			good = end = strchr(ptr, '!');
			if(end)
				*end = 0;
            else
                printf("\npath: no end");

			if((point = strchr(ptr, '.')) != NULL)
				strcpy(air, point);

			strcpy(add1, ptr);
			if(!strchr(add1, '.') && strlen(add1) <= 4 && add1[0])
				strcat(add1, air);
			if(end)
				*end = '!';
            else
                printf("\npath2: no end");

			good = ptr = end+1;
			end = NULL;

			good = end = strchr(ptr, '!');
			if(end)
				*end = 0;

			strcpy(add2, ptr);
			if(!strchr(add2, '.') && strlen(add2) <= 4 && add2[0])
				strcat(add2, air);
			if(end)
				*end = '!';

			if(add1[0] && add2[0] && stricmp(add1, add2))
				linkstat(add1, add2);

		} while(good);
}

/************************************************************************/
/* linkstat() - this is used by pathstat.                               */
/************************************************************************/
void linkstat(label alias1, label alias2)
{
int linknum, lpc;
link* lp;
link* newlink;

	for (lpc=0, lp = firstlink, linknum=-1; lpc < numlink; ++lpc, lp = lp->next)
		if((!strcmp(lp->add1, alias1) && !strcmp(lp->add2, alias2)) ||
		   (!strcmp(lp->add1, alias2) && !strcmp(lp->add2, alias1))) {
			linknum=lpc;
			break;
		}

	if (linknum==-1) {
        display = 1;

		numlink++;
		linknum=numlink-1;

		if(currlink == NULL) {
			/* no current elements. */
			firstlink = currlink = (link *)malloc(sizeof(link));
			currlink->next = NULL;
		} else {
			/* at least one element exists. */
			newlink = (link *)malloc(sizeof(link));
			newlink->next = NULL;
			currlink->next = newlink;
			currlink = newlink;
		}

		printf("New link: %s!%s\n", alias1, alias2);
		fprintf(msgout, " New link: %s!%s detected.\n", alias1, alias2);

		strcpy(currlink->add1, alias1);
		strcpy(currlink->add2, alias2);
		currlink->date = msgbuf.ldate;
        currlink->expired = 0;
	} else {
        if(lp->expired) {
            printf("%s<->%s has been revived after aprox. %f days of inactivity.\n",
                   lp->add1, lp->add2, difftime(msgbuf.ldate, lp->date) / 86400L);
            fprintf(msgout, " %s<->%s has been revived after aprox. %f days of inactivity.\n",
                    lp->add1, lp->add2, difftime(msgbuf.ldate, lp->date) / 86400L);
            lp->expired = 0;
            display     = 1;
        }

        if(msgbuf.ldate > lp->date)
            lp->date = msgbuf.ldate;
	}
}

/* -------------------------------------------------------------------- */
/*  isaddress() examines string and returns true if it looks like an    */
/*              alias (xxx.xxxx)                                        */
/* --------------------------------------------------------------------
    94Sep26 22:48:28 From Brent Bottles @ The Anticlimactic Teleservice, 
Seattle In WAN Admin>
"St. Dism" continues to be less than valid as an address.				*/

int isaddress(const char *str)
{
int len;
int dotpos;
int FoundDot = FALSE;
int i;

	len = strlen(str);

	// Don't be fooled by "St. Dism"
	if (strchr(str, ' ') != NULL)
		return (FALSE);

	for (i = 0; i < len; i++)
	{
		if (str[i] == '.')
		{
			// we can only have one dot.
			if (FoundDot)
			{
				return (FALSE);
			}

			dotpos = i;
			FoundDot = TRUE;
		}
	}

	if  (   // 1, 2, or 3 chars, no dots
			((len > 1) && (len < 4) && !FoundDot)

			||

			// 4, 5, 6, 7, or 8 chars, there is a dot, and it is at char
			// pos 2, 3, or 4, and not too close to the end.
			(   (len > 3) && (len < 9) && FoundDot && (dotpos > 1) &&
				(dotpos < 4) && ((len - dotpos) < 6)
			)
		)
	{
		return (TRUE);
	}
	return (FALSE);
}

/*  
 (That 'Don't be fooled by "St. Dism"' comment is a little out-of-date: 
checking for the position of the dot was added later, and "St. Dism" would fail
that.  However, this check is still good to do, as "poo.po o" would pass the 
dotpos test, but fail the strchr() test.) 

------
i'm cute
*/

/* -------------------------------------------------------------------- */
/*  GetStr()        gets a null-terminated string from a file           */
/* -------------------------------------------------------------------- */
int GetStr(FILE *fil, char *str, int mlen)
{
	int   l = 0;
    int  ch = 1;

    while(ch != EOF && ch)
    {
		ch=getc(fil);
		if(l < mlen)
		{
			str[l++]=ch;
		}
	}
	str[l] = 0;
	return(l);
}

/* -------------------------------------------------------------------- */
/*  LenStr()        Same as GetStr, but this just dumps the input.      */
/*  This is, of course, another attempt at optimization..doesn't really */
/*  help, though.                                                       */
/* -------------------------------------------------------------------- */
int LenStr(FILE *fil)
{
	int   l = 0;
	int  ch;

	do {
		ch=fgetc(fil);
		l++;
	} while(ch && ch != EOF);

	return(l);
}

/************************************************************************/
/* expire()                                                             */
/************************************************************************/
void expire(void)
{
link*	lp;

	for (lp = firstlink; lp; lp = lp->next)
		if(!lp->expired && ((long)time(NULL) - lp->date) > 2592000L) {
            lp->expired = 1;
            expired++;
            printf("%s<->%s has been dormant since %s",
                   lp->add1, lp->add2, ctime(&lp->date));
            fprintf(msgout, " %s<->%s has been dormant since %s",
                    lp->add1, lp->add2, ctime(&lp->date));
            display = 1;
        }
}

/* -------------------------------------------------------------------- */
/*  startup...  opens all files.                                        */
/* -------------------------------------------------------------------- */
void startup(void)
{
link*	newlink;
FILE	*data;
char	datafile[129] = "c:\\c\\scanner\\scanner.dat";
label	temp = "";		// add1
label	temp2 = "";		// add2
label	temp3 = "";		// date
label   exp = "";       // expired

	if((msgdat = fopen(inputmail, "rb")) == NULL) {
		printf(" I can't seem to find \"%s\".\n", inputmail);
		exit(1);
	}

	setvbuf(msgdat, NULL, _IOFBF, 4096);

    GetStr(msgdat, fromalias, 30);

    printf("Processing packet from: %s\n", fromalias);

	if((msgout = fopen(outputfile, "wt")) == NULL) {
		printf(" I can't seem to open \"%s\" for output.\n", outputfile);
		exit(1);
	}

	if((data = fopen(datafile, "rb")) == NULL) {
		printf("can't find data file...  (this is normal on the first run.)\n");
	} else {
		printf("Found data file \"%s\".\n", datafile);

		while(!feof(data)) {
			GetStr(data, temp, 30);
			GetStr(data, temp2, 30);
			GetStr(data, temp3, 30);
            GetStr(data, exp, 30);
			fgetc(data);            // get the newline...

			if(!temp[0] || !temp2[0] || feof(data))
				continue;

			numlink++;

			if(currlink == NULL) {
				/* no current elements. */
				firstlink = currlink = (link *)malloc(sizeof(link));
				currlink->next = NULL;
			} else {
				/* at least one element exists. */
				newlink = (link *)malloc(sizeof(link));
				newlink->next = NULL;
				currlink->next = newlink;
				currlink = newlink;
			}
			strcpy(currlink->add1, temp);
			strcpy(currlink->add2, temp2);
			currlink->date = atol(temp3);
            currlink->expired = atoi(exp);
		}
	}

	fclose(data);
	printf("%d links loaded.\n", numlink);
	fprintf(msgout, " Scanner %s.\t%d links loaded.\tProcessing packet from %s.\n"
                    " \n", version, numlink, fromalias);
}

/**************/
/* shutdown() */
/**************/
void	shutdown(void)
{
link*	lp;
FILE	*data;
char	datafile[129] = "c:\\c\\scanner\\scanner.dat";

	if((data = fopen(datafile, "wb")) == NULL) {
		printf("can't open data file...\n");
	} else {
		for (lp = firstlink; lp; lp = lp->next)
			if(lp->add1[0] && lp->add2[0])
                fprintf(data, "%s%c%s%c%ld%c%d%c\n", lp->add1, 0x00,
                        lp->add2, 0x00, lp->date, 0x00, lp->expired, 0x00);
	}
	fprintf(msgout, " \n"
                    " %d links expired.\t%d links saved.\n",
                    expired, numlink);
}